// TinyPad.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "TinyPad.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>

#include <commdlg.h>
#include <string.h>

#ifndef ChooseFont
#define MYCHOOSEFONT
#endif

#ifdef	MYCHOOSEFONT
#include "fonts.h"
#endif	// MYCHOOSEFONT

#include "find.h"

#define UNICODE_MARK	0xfeff

// Global Variables:

TCHAR				szTitle[MAX_LOADSTRING];	// The title bar text
TCHAR				szSaveFile[MAX_LOADSTRING];
TCHAR				szNotFound[MAX_LOADSTRING];

// Local Variables:

static HINSTANCE	hInst;		// The current instance
static HWND			hwndCB;		// The command bar handle
static HWND			hMainWnd;	// Main window handle

static SHACTIVATEINFO s_sai;

static HWND			hEdit;

static HFONT		hFont;

static BOOL			isUnicodeFile;
static BOOL			isModified;

static TCHAR		FileName[MAX_PATH];
static TCHAR		IniFile[MAX_PATH];

static FINDSTR		fs;

// Forward declarations of functions included in this code module:

ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, LPTSTR, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);


/*
 *	MulDiv
 */
int MulDiv(int m1, int m2, int d)
{
	__int64 x;

	x = (__int64)m1 * (__int64)m2 * 100;
	x = x / d + 50;
	return (int)(x / 100);
}

//
//	SaveSettings
//
static void SaveSettings(LPLOGFONT plf)
{
	HANDLE hfile = NULL;
	DWORD size;
	TCHAR buf[256];

	wsprintf(buf, TEXT("FontInfo=%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%d,%s"),
		plf->lfHeight,
		plf->lfWidth,
		plf->lfEscapement,
		plf->lfOrientation,
		plf->lfWeight,
		plf->lfItalic,
		plf->lfUnderline,
		plf->lfStrikeOut,
		plf->lfCharSet,
		plf->lfOutPrecision,
		plf->lfClipPrecision,
		plf->lfQuality,
		plf->lfPitchAndFamily,
		plf->lfFaceName);

	// Save to file.
	hfile = CreateFile(IniFile, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0);
	if (!hfile)
		return;

	if (!WriteFile(hfile, buf, wcslen(buf) * sizeof(TCHAR), &size, NULL))
		goto out;

out:
	if (hfile)
		CloseHandle(hfile);
}

//
//	LoadSettings
//
static void LoadSettings()
{
	HANDLE hfile = NULL;
	TCHAR buf[256];
	TCHAR *pbuf;
	DWORD nread;
	LOGFONT lf;
	HFONT hOldFont;

	hfile = CreateFile(IniFile, GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
	if (!hfile)
		return;

	memset(buf, 0, sizeof buf);
	if (!ReadFile(hfile, buf, sizeof buf, &nread, NULL))
		goto out;

	pbuf = buf;
	if (wcsncmp(pbuf, TEXT("FontInfo="), 9) != 0)
		goto out;
	pbuf += 9;

	lf.lfHeight = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfWidth = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfEscapement = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfOrientation = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfWeight = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfItalic = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfUnderline = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfStrikeOut = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfCharSet = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfOutPrecision = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfClipPrecision = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfQuality = _atoi(&pbuf);
	pbuf++;		// skip ','
	lf.lfPitchAndFamily = _atoi(&pbuf);
	pbuf++;		// skip ','
	wcscpy(lf.lfFaceName, pbuf);

	// Select new font.
	hOldFont = hFont;
	hFont = CreateFontIndirect(&lf);
	SendMessage(hEdit, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(1, 0));
	DeleteObject(hOldFont);

out:
	if (hfile)
		CloseHandle(hfile);
}

//
//	_basename
//
static void _basename(PTCHAR pdst, PTCHAR psrc)
{
	PTCHAR p;

	p = psrc;
	while (*psrc) {
		if (*psrc == L'\\')
			p = &psrc[1];
		psrc++;
	}

	while (*p && *p != L'.')	// omit extension
		*pdst++ = *p++;

	*pdst = L'\0';
}

//
//	SetTitle
//
static void SetTitle()
{
	TCHAR buf[256];
	TCHAR title[256];

	isModified = SendMessage(hEdit, EM_GETMODIFY, 0, 0);
	_basename(title, FileName);
	wsprintf(buf, TEXT("%s%s%s%s"),
		isModified ? TEXT("*") : TEXT(""),
		title[0] ? title : TEXT(""),
		title[0] ? TEXT(" - ") : TEXT(""),
		szTitle);
	SetWindowText(hMainWnd, buf);
}

//
//	DisacardBuffer
//
static void DiscardBuffer()
{
	// Discard current buffer.

	SendMessage(hEdit, WM_SETTEXT, 0, (LPARAM)TEXT(""));
	SendMessage(hEdit, EM_SETSEL, 0, 0);
	SendMessage(hEdit, EM_SETMODIFY, FALSE, 0);

	memset(FileName, 0, sizeof FileName);
	isUnicodeFile = FALSE;

	SetTitle();
}

//
//	GetOpenName
//
static BOOL GetOpenName()
{
	BOOL res;
	OPENFILENAME ofn;
	TCHAR namebuf[MAX_PATH];

	wcscpy(namebuf, FileName);

	memset(&ofn, 0, sizeof ofn);
	ofn.lStructSize = sizeof ofn;
	ofn.hwndOwner = hEdit;
	ofn.lpstrFile = namebuf;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = TEXT("Text (*.txt)\0*.txt\0All (*.*)\0*.*\0");

	res = GetOpenFileName(&ofn);
	if (res)
		wcscpy(FileName, namebuf);

	return res;
}

//
//	GetSaveName
//
static BOOL GetSaveName()
{
	BOOL res;
	OPENFILENAME ofn;
	TCHAR namebuf[MAX_PATH];

	wcscpy(namebuf, FileName);

	memset(&ofn, 0, sizeof ofn);
	ofn.lStructSize = sizeof ofn;
	ofn.hwndOwner = hEdit;
	ofn.lpstrFile = namebuf;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrFilter = TEXT("Text (*.txt)\0*.txt\0All (*.*)\0*.*\0");
	ofn.lpstrDefExt = TEXT("txt");

	res = GetSaveFileName(&ofn);
	if (res)
		wcscpy(FileName, namebuf);

	return res;
}

//
//	LoadFile
//
static BOOL LoadFile()
{
	BOOL res = FALSE;
	PTCHAR pbuf = NULL;
	PTCHAR pdst = NULL;
	HANDLE hfile = NULL;
	DWORD size;
	DWORD dstsize;
	DWORD nread;
	int count;
	int ret;

	// Open the file.
	hfile = CreateFile(FileName, GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
	if (!hfile) {
		MessageBox(hEdit, TEXT("CreateFile: failed."), szTitle, MB_OK);
		goto done;
	}
	size = GetFileSize(hfile, NULL);
	if (size == 0xFFFFFFFF) {
		MessageBox(hEdit, TEXT("GetFileSize: failed."), szTitle, MB_OK);
		goto done;
	}

	pbuf = (PTCHAR)LocalAlloc(0, size + sizeof(TCHAR));
	if (!pbuf) {
		MessageBox(hEdit, TEXT("No memory."), szTitle, MB_OK);
		goto done;
	}
	if (!ReadFile(hfile, pbuf, size, &nread, NULL)) {
		MessageBox(hEdit, TEXT("ReadFile: failed."), szTitle, MB_OK);
		goto done;
	}

	// Check unicode text or not.
	isUnicodeFile = (pbuf[0] == UNICODE_MARK);
	if (isUnicodeFile) {
		count = size / sizeof(TCHAR);
		pbuf[count] = 0;	// null terminate

		pdst = &pbuf[1];
	} else {
		count = MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pbuf, size, NULL, 0);
		if (!count) {
			MessageBox(hEdit, TEXT("Conversion failed."), szTitle, MB_OK);
			goto done;
		}
		dstsize = (count + 1) * sizeof(TCHAR);	// including null
		pdst = (PTCHAR)LocalAlloc(LMEM_FIXED, dstsize);
		if (!pdst) {
			MessageBox(hEdit, TEXT("No memory."), szTitle, MB_OK);
			goto done;
		}
		ret = MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pbuf, size, pdst, dstsize);
		if (!ret) {
			MessageBox(hEdit, TEXT("Conversion failed."), szTitle, MB_OK);
			goto done;
		}

		pdst[count] = 0;	// null terminate
	}

	if (!SendMessage(hEdit, WM_SETTEXT, 0, (LPARAM)pdst)) {
		MessageBox(hEdit, TEXT("WM_SETTEXT: failed."), szTitle, MB_OK);
		goto done;
	}

	SetTitle();

	res = TRUE;

	// TODO: Set file name to window title.

done:
	if (hfile)
		CloseHandle(hfile);
	if (pbuf)
		LocalFree(pbuf);
	if (pdst)
		LocalFree(pbuf);

	return res;
}

//
//	SaveFile
//
static BOOL SaveFile()
{
	BOOL res = FALSE;
	PTCHAR pbuf = NULL;
	PTCHAR psrc;
	PTCHAR pdst = NULL;
	HANDLE hfile = NULL;
	DWORD size;
	DWORD bufsize;
	DWORD dstsize;
	DWORD wsize;
	int count;
	int ret;

	// Get edit text.
	count = SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0);
	size = count * sizeof(TCHAR);
	bufsize = size + sizeof(TCHAR) * 2;	// null + unicode_mark
	pbuf = (PTCHAR)LocalAlloc(0, bufsize);
	if (!pbuf) {
		MessageBox(hEdit, TEXT("No memory."), szTitle, MB_OK);
		goto done;
	}

	psrc = &pbuf[1];
	SendMessage(hEdit, WM_GETTEXT, count + 1, (LPARAM)psrc);

	// Check unicode text or not.
	if (isUnicodeFile) {
		pbuf[0] = UNICODE_MARK;	// Mark file as Unicode

		pdst = pbuf;
		dstsize = sizeof(TCHAR) + size;	// Including Unicode mark
	} else {
		dstsize = WideCharToMultiByte(CP_ACP, 0, psrc, count, NULL, 0, NULL, NULL);
		if (!dstsize) {
			MessageBox(hEdit, TEXT("Conversion failed."), szTitle, MB_OK);
			goto done;
		}
		pdst = (PTCHAR)LocalAlloc(LMEM_FIXED, dstsize);
		if (!pdst) {
			MessageBox(hEdit, TEXT("No memory."), szTitle, MB_OK);
			goto done;
		}
		ret = WideCharToMultiByte(CP_ACP, 0, psrc, count, (LPSTR)pdst, dstsize, NULL, NULL);
		if (!ret) {
			MessageBox(hEdit, TEXT("Conversion failed."), szTitle, MB_OK);
			goto done;
		}
	}

	// Save to file.
	hfile = CreateFile(FileName, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, 0, 0);
	if (!hfile) {
		MessageBox(hEdit, TEXT("CreateFile: failed."), szTitle, MB_OK);
		goto done;
	}
	if (!WriteFile(hfile, pdst, dstsize, &wsize, NULL)) {
		MessageBox(hEdit, TEXT("WriteFile: failed."), szTitle, MB_OK);
		goto done;
	}

	SendMessage(hEdit, EM_SETMODIFY, FALSE, 0);

	SetTitle();

	res = TRUE;

done:
	if (hfile)
		CloseHandle(hfile);
	if (pbuf)
		LocalFree(pbuf);
	if (pdst)
		LocalFree(pdst);

	return res;
}

//
//	CheckSave
//
static BOOL CheckSave(PTCHAR ptitle)
{
	int res;

	if (SendMessage(hEdit, EM_GETMODIFY, 0, 0)) {
		res = MessageBox(hMainWnd, szSaveFile, ptitle, MB_YESNOCANCEL);
		if (res == IDCANCEL)
			return FALSE;
		else if (res == IDYES) {
			if (!GetSaveName())
				return FALSE;
			if (!SaveFile())
				return FALSE;
		}
	}

	return TRUE;
}

static WNDPROC pEditProc;

//
//	EditSubProc
//
static LRESULT CALLBACK EditSubProc(HWND hWnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	int res;

	switch (msg) {
	case WM_COMMAND:
		return WndProc(hMainWnd, msg, wparam, lparam);
	case WM_LBUTTONDOWN:
		res = WndProc(hMainWnd, msg, wparam, lparam);
		if (res)
			return res;
	}
	return CallWindowProc(pEditProc, hWnd, msg, wparam, lparam);
}


//
//	WinMain
//
int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, lpCmdLine, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_TINYPAD);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TINYPAD));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name
	RECT rc;
	int len;
	BOOL hasFile;

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_TINYPAD, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	LoadString(hInstance, IDS_SAVEFILE, szSaveFile, MAX_LOADSTRING);
	LoadString(hInstance, IDS_NOTFOUND, szNotFound, MAX_LOADSTRING);

	//If it is already running, then focus on the window
	hasFile = (lpCmdLine && lpCmdLine[0]);
	hMainWnd = FindWindow(szWindowClass, NULL);	
	if (hMainWnd)
	{
		// set focus to foremost child window
		// The "| 0x01" is used to bring any owned windows to the foreground and
		// activate them.
		SetForegroundWindow((HWND)((ULONG) hMainWnd | 0x00000001));

		// Sent document name to the active process.
		if (hasFile) {
			COPYDATASTRUCT cds;

			cds.cbData = (wcslen(lpCmdLine) + 1) * sizeof(TCHAR);	// Including nul
			cds.lpData = lpCmdLine;
			SendMessage(hMainWnd, WM_COPYDATA, (WPARAM)hMainWnd, (LPARAM)&cds);
		}

		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	hMainWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hMainWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	if (hwndCB)
    {
        RECT rcMenuBar;

		GetWindowRect(hMainWnd, &rc);
        GetWindowRect(hwndCB, &rcMenuBar);
		rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
		
		MoveWindow(hMainWnd, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
	}

    GetWindowRect(hMainWnd, &rc);
	if (!(hEdit = CreateWindow(L"edit", NULL,
		WS_CHILD | WS_VISIBLE | ES_MULTILINE | WS_VSCROLL |
		ES_AUTOVSCROLL | ES_NOHIDESEL,
		0, 0, rc.right - rc.left, rc.bottom - rc.top,
		hMainWnd, NULL, hInstance, NULL))) {
		DestroyWindow(hMainWnd);
		return FALSE;
	}

	pEditProc = (WNDPROC)SetWindowLong(hEdit, GWL_WNDPROC, (LONG)EditSubProc);

	SendMessage(hEdit, EM_LIMITTEXT, -1, 0);	// set to max (=65535 characters)

	hFont = (HFONT)GetStockObject(SYSTEM_FONT);

	GetModuleFileName(NULL, IniFile, sizeof IniFile);
	len = wcslen(IniFile);
	if (len > 3)
		wcscpy(&IniFile[len - 3], TEXT("ini"));

	LoadSettings();

	// Load file if file was associated.
	if (hasFile) {
		wcscpy(FileName, lpCmdLine);
		(void)LoadFile();
	}

	ShowWindow(hMainWnd, nCmdShow);
	UpdateWindow(hMainWnd);

	SetFocus(hMainWnd);

	return TRUE;
}
//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	BOOL modify;
	int count;
	TCHAR tbuf[MAX_PATH];
	POINT pt;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 

			// Handle events:
			switch (wmEvent) {
				case EN_UPDATE:
					modify = SendMessage(hEdit, EM_GETMODIFY, 0, 0);
					if (modify != isModified)
						SetTitle();
					break;
			}

			// Parse the menu selections:
			switch (wmId)
			{	
				case IDM_HELP_ABOUT:
					DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				    break;

				case IDM_FILE_NEW:

					if (!CheckSave(TEXT("New")))
						break;

					DiscardBuffer();

					break;

				case IDM_FILE_OPEN:

					if (!CheckSave(TEXT("Open")))
						break;

					if (!GetOpenName())
						break;

					if (!LoadFile())
						break;

					break;

				case IDM_FILE_SAVE:

					if (!FileName[0]) {
						if (!GetSaveName())
							break;
					}

					if (!SaveFile())
						break;

					break;

				case IDM_FILE_SAVEAS:

					if (!GetSaveName())
						break;
					
					if (!SaveFile())
						break;

					break;

				case IDM_FILE_EXIT:

					if (!CheckSave(szTitle))
						break;

					SendMessage (hWnd, WM_DESTROY, 0, 0);
					break;

				case IDOK:
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;

				case IDM_EDIT_UNDO:
					SendMessage(hEdit, EM_UNDO, 0, 0);
					break;

				case IDM_EDIT_CUT:
					SendMessage(hEdit, WM_CUT, 0, 0);
					break;

				case IDM_EDIT_COPY:
					SendMessage(hEdit, WM_COPY, 0, 0);
					break;

				case IDM_EDIT_PASTE:
					SendMessage(hEdit, WM_PASTE, 0, 0);
					break;

				case IDM_EDIT_SELECTALL:
					SendMessage(hEdit, EM_SETSEL, 0, -1);
					break;

				case IDM_EDIT_PAGEUP:
					GetCaretPos(&pt);
					SendMessage(hEdit, EM_SCROLL, SB_PAGEUP, 0);
					SendMessage(hEdit, WM_LBUTTONDOWN, MK_LBUTTON, MAKELPARAM(pt.x, pt.y + 1));
					SendMessage(hEdit, WM_LBUTTONUP, MK_LBUTTON, MAKELPARAM(pt.x, pt.y + 1));
					break;

				case IDM_EDIT_PAGEDOWN:
					GetCaretPos(&pt);
					SendMessage(hEdit, EM_SCROLL, SB_PAGEDOWN, 0);
					SendMessage(hEdit, WM_LBUTTONDOWN, MK_LBUTTON, MAKELPARAM(pt.x, pt.y + 1));
					SendMessage(hEdit, WM_LBUTTONUP, MK_LBUTTON, MAKELPARAM(pt.x, pt.y + 1));
					break;

				case IDM_EDIT_HOME:
					SendMessage(hEdit, EM_SETSEL, 0, 0);
					SendMessage(hEdit, EM_SCROLLCARET, 0, 0);
					break;

				case IDM_EDIT_END:
					count = SendMessage(hEdit, WM_GETTEXTLENGTH, 0, 0);
					SendMessage(hEdit, EM_SETSEL, count, count);
					SendMessage(hEdit, EM_SCROLLCARET, 0, 0);
					break;

				case IDM_EDIT_FIND:
					fs.hInst = hInst;
					fs.hWnd = hEdit;
					fs.nFindStr = MAX_PATH - 1;

					if (!GetFindStr(&fs))
						break;
					if (fs.nFindStr == 0)
						break;

					// Find the string
					fs.BackSearch = FALSE;
					if (!FindStr(&fs)) {
						wsprintf(tbuf, TEXT("\"%s\"%s"), fs.aFindStr, szNotFound);
						MessageBox(hWnd, tbuf, szTitle, MB_ICONINFORMATION | MB_OK);
					}
					break;
					
				case IDM_EDIT_FINDPREV:
					if (fs.nFindStr == 0)
						break;

					fs.hInst = hInst;
					fs.hWnd = hEdit;
					fs.BackSearch = TRUE;

					// Find the string
					if (!FindStr(&fs)) {
						wsprintf(tbuf, TEXT("\"%s\"%s"), fs.aFindStr, szNotFound);
						MessageBox(hWnd, tbuf, szTitle, MB_ICONINFORMATION | MB_OK);
					}
					break;

				case IDM_EDIT_FINDNEXT:
					if (fs.nFindStr == 0)
						break;

					fs.hInst = hInst;
					fs.hWnd = hEdit;
					fs.BackSearch = FALSE;

					// Find the string
					if (!FindStr(&fs)) {
						wsprintf(tbuf, TEXT("\"%s\"%s"), fs.aFindStr, szNotFound);
						MessageBox(hWnd, tbuf, szTitle, MB_ICONINFORMATION | MB_OK);
					}
					break;

				case IDM_EDIT_REPL:
					fs.hInst = hInst;
					fs.hWnd = hEdit;
					fs.nFindStr = MAX_PATH - 1;
					fs.nReplStr = MAX_PATH - 1;

					if (!GetReplStr(&fs))
						break;
					if (fs.nFindStr == 0 || fs.nReplStr == 0)
						break;

					// Find the string
					fs.BackSearch = FALSE;
					if (!FindStr(&fs)) {
						wsprintf(tbuf, TEXT("\"%s\"%s"), fs.aFindStr, szNotFound);
						MessageBox(hWnd, tbuf, szTitle, MB_ICONINFORMATION | MB_OK);
					}
					break;

				case IDM_EDIT_REPLNEXT:
					if (fs.nFindStr == 0 || fs.nReplStr == 0)
						break;

					fs.hInst = hInst;
					fs.hWnd = hEdit;
					fs.BackSearch = FALSE;

					// Find the string
					if (!ReplStr(&fs)) {
						wsprintf(tbuf, TEXT("\"%s\"%s"), fs.aFindStr, szNotFound);
						MessageBox(hWnd, tbuf, szTitle, MB_ICONINFORMATION | MB_OK);
					}

					// Go to the next string
					SendMessage(hWnd, WM_COMMAND, IDM_EDIT_FINDNEXT, 0);
					break;

				case IDM_TOOLS_FONT: {
					CHOOSEFONT cf;
					HFONT hOldFont;
					LOGFONT lf;

					// Choose font.
					GetObject(hFont, sizeof lf, &lf);
					memset(&cf, 0, sizeof cf);
					cf.lStructSize = sizeof cf;
					cf.hInstance = hInst;
					cf.hwndOwner = hWnd;
					cf.lpLogFont = &lf;
					cf.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT | CF_LIMITSIZE;
					cf.nSizeMin = 3;
					cf.nSizeMax = 72;
					if (!ChooseFont(&cf))
						break;

					// Select new font.
					hOldFont = hFont;
					hFont = CreateFontIndirect(&lf);
					SendMessage(hEdit, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(1, 0));
					DeleteObject(hOldFont);

					GetObject(hFont, sizeof lf, &lf);	// Reload

					// Save settings.
					SaveSettings(&lf);
					}
					break;

				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			hwndCB = CreateRpCommandBar(hWnd);
            // Initialize the shell activate info structure
            memset (&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);

			isUnicodeFile = FALSE;

			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			EndPaint(hWnd, &ps);
			break; 
		case WM_DESTROY:
			DeleteObject(hFont);
			CommandBar_Destroy(hwndCB);
			PostQuitMessage(0);
			break;
		case WM_ACTIVATE:
            // Notify shell of our activate message
			SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
			if (wParam != WA_INACTIVE)
				SetFocus(hEdit);
			else
				SendMessage(hEdit, message, wParam, lParam);
     		break;
		case WM_SETTINGCHANGE:
			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
     		break;
		case WM_SETFOCUS:
			SetFocus(hEdit);
			break;
		case WM_KILLFOCUS:
			SendMessage(hEdit, message, wParam, lParam);
			break;
		case WM_SIZE:
			MoveWindow(hEdit, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
			break;
		case WM_LBUTTONDOWN:
			{
				SHRGINFO shrg;
				int x, y;
				int cmd;

				x = LOWORD(lParam);
				y = HIWORD(lParam);

				memset(&shrg, 0, sizeof shrg);
				shrg.cbSize = sizeof shrg;
				shrg.hwndClient = hEdit;
				shrg.ptDown.x = x;
				shrg.ptDown.y = y;
				shrg.dwFlags = SHRG_RETURNCMD;
				if (SHRecognizeGesture(&shrg) == GN_CONTEXTMENU) {
					HMENU hMenuPopup;

					// Create popup menu
					hMenuPopup = CreatePopupMenu();

					AppendMenu(hMenuPopup, MF_ENABLED|MF_STRING, IDM_EDIT_UNDO, TEXT("Undo"));
					AppendMenu(hMenuPopup, MF_SEPARATOR, 0, 0);
					AppendMenu(hMenuPopup, MF_ENABLED|MF_STRING, IDM_EDIT_CUT, TEXT("Cut"));
					AppendMenu(hMenuPopup, MF_ENABLED|MF_STRING, IDM_EDIT_COPY, TEXT("Copy"));
					AppendMenu(hMenuPopup, MF_ENABLED|MF_STRING, IDM_EDIT_PASTE, TEXT("Paste"));
					AppendMenu(hMenuPopup, MF_SEPARATOR, 0, 0);
					AppendMenu(hMenuPopup, MF_ENABLED|MF_STRING, IDM_EDIT_SELECTALL, TEXT("Select All"));

					cmd = TrackPopupMenu(hMenuPopup, TPM_LEFTALIGN | TPM_TOPALIGN,
						x, y, 0, hEdit, NULL);

					DestroyMenu(hMenuPopup);

					return cmd;
				}
			}
			break;
		case WM_COPYDATA:
			// Sent from another process.
			PCOPYDATASTRUCT pcds;

			pcds = (PCOPYDATASTRUCT)lParam;

			if (!CheckSave(TEXT("Save")))
				break;

			wcsncpy(FileName, (LPCTSTR)pcds->lpData, MAX_PATH);

			if (!LoadFile())
				break;

			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi)) 
		return NULL;

	return mbi.hwndMB;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
			SHInitDialog(&shidi);
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK)
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
